using System;

namespace ConsoleApp33
{
    class Program
    {
        static int najveci = 0;
        static void izlomi(string tekst, int trenutni)
        {
            if (tekst.Length > 0)
            {
                for (int i=0; i < tekst.Length - 1; i++)
                {
                    int pomeraj = 0, pomoc = 0;
                    while (i-pomeraj>=0 && i + 1 + pomeraj < tekst.Length)
                    {
                        if (tekst[i - pomeraj] == tekst[i + 1 + pomeraj]) pomoc++;
                        pomeraj++;
                    }
                    izlomi(tekst.Substring(i+1), trenutni+pomoc);
                }
            }
            if (trenutni > najveci) najveci = trenutni;
        }
        static void Main(string[] args)
        {

            string tekst = Console.ReadLine();
            izlomi(tekst,0);
            Console.WriteLine(najveci);

        }
    }
}